diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/flow-monitor/bindings/modulegen__gcc_LP64.py ns-3.32/src/flow-monitor/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/flow-monitor/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/flow-monitor/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -7530,12 +7630,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0, unsigned int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('unsigned int', 'arg1')], 
-                   is_pure_virtual=True, is_virtual=True, custom_name='__call__')
+                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
     return
 
 def register_Ns3QueueDiscItem_methods(root_module, cls):
@@ -7578,7 +7678,7 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## queue-item.h (module 'network'): bool ns3::QueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
@@ -7588,7 +7688,7 @@
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation', default_value='0')], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/flow-monitor/model/flow-monitor.cc ns-3.32/src/flow-monitor/model/flow-monitor.cc
--- ns-3.31/src/flow-monitor/model/flow-monitor.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/flow-monitor/model/flow-monitor.cc	2020-10-06 15:35:43.000000000 -0700
@@ -302,7 +302,7 @@
 void
 FlowMonitor::CheckForLostPackets (Time maxDelay)
 {
-  NS_LOG_FUNCTION (this << maxDelay.GetSeconds ());
+  NS_LOG_FUNCTION (this << maxDelay.As (Time::S));
   Time now = Simulator::Now ();
 
   for (TrackedPacketMap::iterator iter = m_trackedPackets.begin ();
@@ -362,23 +362,23 @@
 void
 FlowMonitor::Start (const Time &time)
 {
-  NS_LOG_FUNCTION (this << time.GetSeconds ());
+  NS_LOG_FUNCTION (this << time.As (Time::S));
   if (m_enabled)
     {
       NS_LOG_DEBUG ("FlowMonitor already enabled; returning");
       return;
     }
   Simulator::Cancel (m_startEvent);
-  NS_LOG_DEBUG ("Scheduling start at " << time.GetSeconds ());
+  NS_LOG_DEBUG ("Scheduling start at " << time.As (Time::S));
   m_startEvent = Simulator::Schedule (time, &FlowMonitor::StartRightNow, this);
 }
 
 void
 FlowMonitor::Stop (const Time &time)
 {
-  NS_LOG_FUNCTION (this << time.GetSeconds ());
+  NS_LOG_FUNCTION (this << time.As (Time::S));
   Simulator::Cancel (m_stopEvent);
-  NS_LOG_DEBUG ("Scheduling stop at " << time.GetSeconds ());
+  NS_LOG_DEBUG ("Scheduling stop at " << time.As (Time::S));
   m_stopEvent = Simulator::Schedule (time, &FlowMonitor::StopRightNow, this);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/flow-monitor/model/ipv4-flow-probe.cc ns-3.32/src/flow-monitor/model/ipv4-flow-probe.cc
--- ns-3.31/src/flow-monitor/model/ipv4-flow-probe.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/flow-monitor/model/ipv4-flow-probe.cc	2020-10-06 15:35:43.000000000 -0700
@@ -254,12 +254,12 @@
 
   std::ostringstream qd;
   qd << "/NodeList/" << node->GetId () << "/$ns3::TrafficControlLayer/RootQueueDiscList/*/Drop";
-  Config::ConnectWithoutContext (qd.str (), MakeCallback (&Ipv4FlowProbe::QueueDiscDropLogger, Ptr<Ipv4FlowProbe> (this)));
+  Config::ConnectWithoutContextFailSafe (qd.str (), MakeCallback (&Ipv4FlowProbe::QueueDiscDropLogger, Ptr<Ipv4FlowProbe> (this)));
 
   // code copied from point-to-point-helper.cc
   std::ostringstream oss;
   oss << "/NodeList/" << node->GetId () << "/DeviceList/*/TxQueue/Drop";
-  Config::ConnectWithoutContext (oss.str (), MakeCallback (&Ipv4FlowProbe::QueueDropLogger, Ptr<Ipv4FlowProbe> (this)));
+  Config::ConnectWithoutContextFailSafe (oss.str (), MakeCallback (&Ipv4FlowProbe::QueueDropLogger, Ptr<Ipv4FlowProbe> (this)));
 }
 
 Ipv4FlowProbe::~Ipv4FlowProbe ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/flow-monitor/model/ipv6-flow-probe.cc ns-3.32/src/flow-monitor/model/ipv6-flow-probe.cc
--- ns-3.31/src/flow-monitor/model/ipv6-flow-probe.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/flow-monitor/model/ipv6-flow-probe.cc	2020-10-06 15:35:43.000000000 -0700
@@ -224,12 +224,12 @@
 
   std::ostringstream qd;
   qd << "/NodeList/" << node->GetId () << "/$ns3::TrafficControlLayer/RootQueueDiscList/*/Drop";
-  Config::ConnectWithoutContext (qd.str (), MakeCallback (&Ipv6FlowProbe::QueueDiscDropLogger, Ptr<Ipv6FlowProbe> (this)));
+  Config::ConnectWithoutContextFailSafe (qd.str (), MakeCallback (&Ipv6FlowProbe::QueueDiscDropLogger, Ptr<Ipv6FlowProbe> (this)));
 
   // code copied from point-to-point-helper.cc
   std::ostringstream oss;
   oss << "/NodeList/" << node->GetId () << "/DeviceList/*/TxQueue/Drop";
-  Config::ConnectWithoutContext (oss.str (), MakeCallback (&Ipv6FlowProbe::QueueDropLogger, Ptr<Ipv6FlowProbe> (this)));
+  Config::ConnectWithoutContextFailSafe (oss.str (), MakeCallback (&Ipv6FlowProbe::QueueDropLogger, Ptr<Ipv6FlowProbe> (this)));
 }
 
 /* static */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/flow-monitor/wscript ns-3.32/src/flow-monitor/wscript
--- ns-3.31/src/flow-monitor/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/flow-monitor/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -1,7 +1,7 @@
 ## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 def build(bld):
-    obj = bld.create_ns3_module('flow-monitor', ['internet', 'config-store'])
+    obj = bld.create_ns3_module('flow-monitor', ['internet', 'config-store', 'stats'])
     obj.source = ["model/%s" % s for s in [
        'flow-monitor.cc',
        'flow-classifier.cc',
@@ -10,14 +10,11 @@
        'ipv4-flow-probe.cc',
        'ipv6-flow-classifier.cc',
        'ipv6-flow-probe.cc',
-       'histogram.cc',
         ]]
     obj.source.append("helper/flow-monitor-helper.cc")
 
     module_test = bld.create_ns3_module_test_library('flow-monitor')
-    module_test.source = [
-        'test/histogram-test-suite.cc',
-        ]
+    module_test.source = [ ]
 
     # Tests encapsulating example programs should be listed here
     if (bld.env['ENABLE_EXAMPLES']):
@@ -35,7 +32,6 @@
        'ipv4-flow-probe.h',
        'ipv6-flow-classifier.h',
        'ipv6-flow-probe.h',
-       'histogram.h',
         ]]
     headers.source.append("helper/flow-monitor-helper.h")
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/bindings/callbacks_list.py ns-3.32/src/internet/bindings/callbacks_list.py
--- ns-3.31/src/internet/bindings/callbacks_list.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/bindings/callbacks_list.py	2020-10-06 15:35:43.000000000 -0700
@@ -30,9 +30,11 @@
     ['void', 'ns3::SequenceNumber<unsigned int, int>', 'ns3::SequenceNumber<unsigned int, int>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::TcpSocketState::TcpCongState_t', 'ns3::TcpSocketState::TcpCongState_t', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::TcpSocketState::EcnState_t', 'ns3::TcpSocketState::EcnState_t', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::DataRate', 'ns3::DataRate', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'double', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::TcpSocket::TcpStates_t', 'ns3::TcpSocket::TcpStates_t', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'const ns3::TcpHeader &', 'ns3::Ptr<const ns3::TcpSocketBase>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
